package betterwithmods.common.blocks.mechanical.tile;

import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;

public abstract class TileEntityBaseWindmill extends TileAxleGenerator implements IColor {
    protected int[] bladeMeta;
    private boolean rain, thunder;

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        for (int i = 0; i < 4; i++) {
            if (tag.func_74764_b("Color_" + i))
                bladeMeta[i] = tag.func_74762_e("Color_" + i);
        }
        rain = tag.func_74767_n("rain");
        thunder = tag.func_74767_n("thunder");

    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        for (int i = 0; i < 4; i++) {
            t.func_74768_a("Color_" + i, bladeMeta[i]);
        }
        t.func_74774_a("DyeIndex", this.dyeIndex);
        t.func_74757_a("thunder",this.thunder);
        t.func_74757_a("rain",this.rain);
        return t;
    }

    @Override
    public boolean dyeBlade(int dyeColor) {
        boolean dyed = false;
        if (bladeMeta[dyeIndex] != dyeColor) {
            bladeMeta[dyeIndex] = dyeColor;
            dyed = true;
            IBlockState state = getBlockWorld().func_180495_p(this.field_174879_c);
            this.getBlockWorld().func_184138_a(this.field_174879_c, state, state, 3);
            this.func_70296_d();
        }
        dyeIndex++;
        if (dyeIndex > (bladeMeta.length - 1))
            dyeIndex = 0;
        return dyed;
    }


    public int getBladeColor(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public int getColorFromBlade(int blade) {
        return bladeMeta[blade];
    }

    @Override
    public void calculatePower() {
        byte power = 0;
        if (isValid()) {
            if (thunder)
                power = 3;
            else if (rain)
                power = 2;
            else
                power = 1;

            if (tick > 600) {
                if (isOverworld()) {
                    rain = field_145850_b.func_72896_J();
                    thunder = field_145850_b.func_72911_I();
                }
                tick = 0;
            }
        }

        if (power != this.power) {
            setPower(power);
        }
    }


    @Override
    public int getMinimumInput(EnumFacing facing) {
        return 0;
    }
}
