package betterwithmods.module.gameplay.miniblocks;

import betterwithmods.common.blocks.tile.TileBasic;
import betterwithmods.util.SpaceUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;

public class TileMini extends TileBasic {

    public ItemStack texture;
    public Orientation orientation;

    public TileMini() {
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, IBlockState oldState, IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        NBTTagCompound tag = super.func_189515_b(compound);
        tag.func_74782_a("texture", texture.serializeNBT());
        tag.func_74768_a("orientation", orientation.ordinal());
        return tag;
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        texture = new ItemStack((NBTTagCompound) compound.func_74781_a("texture"));
        orientation = Orientation.getOrientation(compound.func_74762_e("orientation"));
        super.func_145839_a(compound);
    }

    @Override
    public void onPlacedBy(EntityLivingBase placer, @Nullable EnumFacing face, ItemStack stack, float hitX, float hitY, float hitZ) {
        loadFromStack(stack);

        orientation = SpaceUtils.getOrientation(func_145831_w(), func_174877_v(), placer, face, 0,0,0);
    }

    public void loadFromStack(ItemStack stack) {
        NBTTagCompound tag = stack.func_77978_p();
        texture = new ItemStack(tag.func_74775_l("texture"));
    }

    private boolean changeOrientation(Orientation newOrientation, boolean simulate) {
        if (orientation != newOrientation) {
            if (!simulate) {
                orientation = newOrientation;
                markBlockForUpdate();
                func_145831_w().func_175722_b(field_174879_c, func_145838_q(), true);
            }
            return true;
        } else {
            return false;
        }
    }

    public void markBlockForRenderUpdate() {
        field_145850_b.func_175704_b(field_174879_c, field_174879_c);
    }

    public void markBlockForUpdate() {
        IBlockState state = field_145850_b.func_180495_p(field_174879_c);
        field_145850_b.func_184138_a(field_174879_c, state, state, 3);
    }
}
